//=========================================================
// src/Interrupts.c: generated by Hardware Configurator
//
// This file will be regenerated when saving a document.
// leave the sections inside the "$[...]" comment tags alone
// or they will be overwritten!
//=========================================================

// USER INCLUDES
#include <SI_EFM8UB1_Register_Enums.h>
#include "ThermocoupleSystem_Defs.h"

//-----------------------------------------------------------------------------
// SPI0_ISR
//-----------------------------------------------------------------------------
//
// SPI0 ISR Content goes here. Remember to clear flag bits:
// SPI0CN0::MODF (Mode Fault Flag)
// SPI0CN0::RXOVRN (Receive Overrun Flag)
// SPI0CN0::SPIF (SPI# Interrupt Flag)
// SPI0CN0::WCOL (Write Collision Flag)
// SPI0FCN1::RFRQ (Receive FIFO Request)
// SPI0FCN1::TFRQ (Transmit FIFO Request)
//
//-----------------------------------------------------------------------------
SI_INTERRUPT (SPI0_ISR, SPI0_IRQn)
{
	unsigned int RawTempData;

	//clear interrupt flag
	SPI0FCN1 &= ~SPI0FCN1_RFRQ__BMASK;

	RawTempData = SPI0DAT;
	RawTempData = (RawTempData << 8) | SPI0DAT;

	//flush Rx FIFO and disable slave select
	SPI0FCN0 |= SPI0FCN0_RFLSH__FLUSH;
	SPI0CN0 |= NSS_BIT;

	/* The following instructions convert the raw
	 * binary temperature data into a format that
	 * can be easily interpreted by Scilab. Refer to
	 * the text of the article for more information.*/
	TempDataTx[0] = LOWBYTE(RawTempData >> 12);
	TempDataTx[1] = LOWBYTE(RawTempData >> 4);

	switch((RawTempData & (BIT3|BIT2)) >> 2)
	{
		case 0: TempDataTx[2] = 0;
		break;

		case 1: TempDataTx[2] = 25;
		break;

		case 2: TempDataTx[2] = 50;
		break;

		case 3: TempDataTx[2] = 75;
		break;
	}

	TEMP_DATA_READY = TRUE;
}

