/*
 * USBInterface.c
 *      Author: RK
 */

#include <SI_EFM8UB1_Register_Enums.h>                  // SFR declarations
#include "VCPXpress.h"
#include "descriptor.h"
#include "ThermocoupleSystem_Defs.h"

uint16_t xdata USBBytesReceived = 0;                   // Holds size of received packet
uint16_t xdata USBBytesTransmitted = 0;			//Holds number of bytes actually transmitted
uint8_t xdata USBRxPacket[USB_PACKET_SIZE];     // Packet received from host

unsigned char TempDataTx[TEMP_DATA_LEN];

bit TEMP_DATA_REQUESTED = FALSE;
bit TEMP_DATA_READY = FALSE;


/**************************************************************************//**
 * VCPXpress callback
 * This function is called by VCPXpress.
 *****************************************************************************/
VCPXpress_API_CALLBACK(myAPICallback)
{
   uint32_t API_InterruptCode;

   //get the code that indicates the reason for the interrupt
   API_InterruptCode = Get_Callback_Source();

   //if the USB connection was just opened
   if (API_InterruptCode & DEVICE_OPEN)
   {
	   //start the first USB read procedure
	   Block_Read(USBRxPacket, USB_PACKET_SIZE, &USBBytesReceived);
	   /*we will process the received bytes when we get
	   a callback with an RX_COMPLETE interrupt code*/
   }

   if (API_InterruptCode & RX_COMPLETE)   // USB read complete
   {
	   if(USBBytesReceived == 1 && USBRxPacket[0] == 'R')
		   TEMP_DATA_REQUESTED = TRUE;

	   //continue with the next USB read procedure
	   Block_Read(USBRxPacket, USB_PACKET_SIZE, &USBBytesReceived);
   }
}

void Transmit_USB_Packet()
{
		Block_Write(TempDataTx, TEMP_DATA_LEN, &USBBytesTransmitted);
}



